﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.OleDb;

namespace DrillThroughForWebII
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        private string connectionstring = "Provider=Microsoft.Jet.OleDb.4.0;Data Source=|DataDirectory|\\NWind.mdb;Persist Security Info=False;";

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                GrapeCity.ActiveReports.PageReport report = new GrapeCity.ActiveReports.PageReport(new System.IO.FileInfo(Server.MapPath("Department.rdlx")));

                WebViewer1.Report = report;
                WebViewer1.LocateDataSource += new GrapeCity.ActiveReports.LocateDataSourceEventHandler(WebViewer1_LocateDataSource);
            }
        }

        void WebViewer1_LocateDataSource(object sender, GrapeCity.ActiveReports.LocateDataSourceEventArgs args)
        {
            switch (args.Report.PageReport.Report.Description)
            {
                case "Department": 
                    // 加载部门数据
                    int departmentid = int.Parse(args.Report.Parameters[0].Values[0].Value.ToString());
                    args.Data = GetDepartmentData(departmentid);
                    break;
                case "Employee":
                    // 加载职员数据
                    int employeeid = int.Parse(args.Report.Parameters[0].Values[0].Value.ToString());
                    args.Data = GetEmployeeData(employeeid);
                    break;
                default:
                    break;
            }
        }

        private DataTable GetDepartmentData(int id)
        {
            DataTable dt = new DataTable();
            using (OleDbConnection connection = new OleDbConnection(connectionstring))
            {
                OleDbDataAdapter adapter = new OleDbDataAdapter("select * from department where ParentID= ?;", connection);
                adapter.SelectCommand.Parameters.Add(new OleDbParameter("ParentID", id));

                adapter.Fill(dt);
            }
            return dt;
        }

        private DataTable GetEmployeeData(int id)
        {
            DataTable dt = new DataTable();
            using (OleDbConnection connection = new OleDbConnection(connectionstring))
            {
                OleDbDataAdapter adapter = new OleDbDataAdapter("select * from Employee where DepartmentID = ?;", connection);
                adapter.SelectCommand.Parameters.Add(new OleDbParameter("DepartmentID", id));

                adapter.Fill(dt);
            }
            return dt;
        }
    }
}